SystemOrganization addCategory: #'AmbientTalkST-Tests'!

ATActor subclass: #ATTracingActor
	instanceVariableNames: 'cnt msgTrace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Tests'!

!ATTracingActor class methodsFor: 'VM support' stamp: 'StefanMarr 7/29/2012 23:12'!
domainCustomizations ^ 16rFFF000! !

!ATTracingActor methodsFor: 'initialization' stamp: 'StefanMarr 1/4/2012 14:56'!
initialize
	cnt := 0.
	msgTrace := OrderedCollection new.
	
	super initialize.! !

!ATTracingActor methodsFor: 'tracing' stamp: 'StefanMarr 1/3/2012 23:54'!
numberOfProcessedMessages
	^ cnt! !

!ATTracingActor methodsFor: 'actor semantics' stamp: 'StefanMarr 7/19/2012 22:47'!
processIncomingMessages
	| msg result |
	<omniUnenforced>
	msg := mailbox next.
	
	result := msg send.
	
	msgTrace addLast: msg selector.
	cnt := cnt + 1.
	
	msg result: result.
	! !

OstTestCase subclass: #ATTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AmbientTalkST-Tests'!

!ATTests methodsFor: 'testing' stamp: 'StefanMarr 4/1/2012 10:28'!
execDomain
	^  OstDomain currentDomain! !

!ATTests methodsFor: 'testing' stamp: 'StefanMarr 1/10/2012 14:24'!
expectedFailures 
	(Smalltalk hasClassNamed: #ATFarReference) ifFalse: [
		^ #(testNewWithInitializerATST)
	].

	^ super expectedFailures! !

!ATTests methodsFor: 'testing' stamp: 'StefanMarr 4/1/2012 10:28'!
onBaselevel
	^ OstMirror executesOnBaseLevel! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 3/24/2012 11:08'!
testActorAndDomain
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ OstDomain currentDomain. 	].
	
	self assert: actor equals: p read.! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 4/1/2012 10:28'!
testActorAndDomainIndirect
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ self execDomain ].
	
	self assert: actor equals: p read.! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 5/2/2012 23:14'!
testEvaluateAsyncOmnified
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	
	 "This one is only for OmniST. The implementation is not stable
	  when run the first time, since we then still have the DNUs
	  on the stack that #executesOnBaseLevel does not handle."
	actor evaluateAsync: [ OstMirror executesOnBaseLevel. ].
	
	p := actor evaluateAsync: [ OstMirror executesOnBaseLevel. ].
	
	self assert: p read.! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 4/1/2012 10:27'!
testEvaluateAsyncOmnifiedIndirect
	"Make sure that the actor is correctly associated with its domain"
	
	| actor p |
	actor := ATActor new.
	p := actor evaluateAsync: [ self onBaselevel ].
	
	self assert: p read.! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 1/3/2012 11:47'!
testNewWithInitializer
	"For the real AmbientTalk feeling"
	| result |
	result := ATActor newWithInitializer: [ATHelloWorld new].
	
	self assert: (result isKindOf: ATHelloWorld).
	! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 1/4/2012 14:12'!
testNewWithInitializerATST
	"For the real AmbientTalk feeling"
	| result |
	result := ATActor newWithInitializer: [ATHelloWorld new].
	
	self assert: (result isKindOf: ATHelloWorld).
	self assert: result class == (Smalltalk at: #ATFarReference).! !

!ATTests methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:49'!
testNewWithInitializerOmni
	"For the real AmbientTalk feeling"
	| result domain |
	result := ATActor newWithInitializer: [ATHelloWorld new].
	
	self assert: (result isKindOf: ATHelloWorld) description: 'Result should be the blocks return value'.
	
	domain := OstMirror domainOf: result.
	self assert: domain notNil description: 'The domain of the ATHelloWorld object should have been properly initialized...'.
	self assert: (domain isKindOf: ATActor) description: '... to the ATActor object.'. ! !
